i#!/bin/sh

###############################################
#
#			Pre Init.
#
###############################################
pre_init_services()
{
	chown -R root /var/empty/sshd
	/sbin/sshd
	chmod 666 /dev/svm0
}


###############################################
#
#			Load Drivers.
#
###############################################

ko_check()
{
	ko=$1

	insmod $ko
	if [ $? -ne 0 ]; then
		echo "[DEBUG] `date` insmod $ko fail"
	else
		echo "[DEBUG] `date` insmod $ko succ"
    fi
}

load_device_modules()
{
	echo "load device modules"
	ko_check /var/drv_dfm.ko
	ko_check /var/drv_mdio.ko
	ko_check /var/drv_gmac.ko
	ko_check /var/drv_lsw.ko
	echo "finish load device modules"
}

###############################################
#
#			Load Config
#
###############################################

PCIVNIC_DEV="eth0"
PCIVNIC_IP="192.168.0.2"
PCIVNIC_NETMASK="255.255.255.0"
config_pcivnic_address()
{
        local ip_addr="$PCIVNIC_IP"
	ifconfig $PCIVNIC_DEV $ip_addr netmask $PCIVNIC_NETMASK
	ifconfig
	echo "configure pcivnic IP success:"
}
###############################################
#
#			main process.
#
###############################################
pre_init_services
load_device_modules
config_pcivnic_address
