#!/bin/sh

minirc_upgrade_log()
{
    cur_time=$(date +%Y-%m-%d,%H:%m:%s)
    echo "$cur_time  $1"
}

#set environment variable
set_environment_variable()
{
	file_conf=/etc/ld.so.conf.d/mind_so.conf
	if [ -f $file_conf ];then
		rm $file_conf
		ldconfig
	fi
	echo /usr/lib64 >> $file_conf
	echo /lib64 >> $file_conf
	ldconfig
}

check_user(){
    ret=`cat /etc/passwd | cut -f1 -d':' | grep -w "$1" -c`
    if [ $ret -le 0 ]; then
        return 1
    else
        return 0
    fi
}

get_boot_partition() {
    boot_cmd_path=/proc/cmdline
    if [ -e ${boot_cmd_path} ]; then
        boot_area=`cat /proc/cmdline | awk '{for(i=1;i<=NF;i++){split($i,cmd_str,"="); if(cmd_str[1]=="slaveboot"){print cmd_str[2]}}}'`
        if [ $boot_area -eq 1 ]; then
            partition_flag="backup"
        fi
    fi
}

username=HwHiAiUser
check_user ${username}
if [ $? -ne 0 ];then
    minirc_upgrade_log "user HwHiAiUser does not exists!" 
    exit 1
fi

INSTALL_CACHE_DIR=$1
partition_flag="main"
minirc_upgrade_log "mini install"
get_boot_partition
if [ ! -d ${INSTALL_CACHE_DIR} ];then
	minirc_upgrade_log "dir ${INSTALL_CACHE_DIR} not exited, install fail"
else
    if [ -e /var/davinci/firmware/upgrade_failed ]; then
        exit 0
    fi
	cd ${INSTALL_CACHE_DIR}
	./check_sha.sh
	if [ $? -ne 0 ];then
		minirc_upgrade_log "mini upgrade fail, package file check fail"
		rm -rf ${INSTALL_CACHE_DIR}
	else
		minirc_upgrade_log "start to install new version($(cat $INSTALL_CACHE_DIR/mini_developerkit/sys_version.conf))"
		
		#copy files to target
		chmod +x ${INSTALL_CACHE_DIR}/mini_developerkit/scripts/*.sh
		${INSTALL_CACHE_DIR}/mini_developerkit/scripts/minirc_cp_file.sh $INSTALL_CACHE_DIR

		#set env value
		set_environment_variable

		#remove cache after copying
		rm -rf ${INSTALL_CACHE_DIR}
	fi
	cd - >/dev/null
fi
