#!/bin/sh

npu_manage_tools="npu-smi"

minirc_upgrade_log()
{
    cur_time=$(date +%Y-%m-%d,%H:%M:%S)
	if [ ! -e /var/davinci/log/upgrade.log ]; then
		mkdir -p /var/davinci/log
		echo "$cur_time  create log file" > /var/davinci/log/upgrade.log
	fi
    echo "$cur_time  $1" >> /var/davinci/log/upgrade.log
    echo "$cur_time  $1"
}

install_npu_manage_tools() 
{
	local src_dir=$1
	local tools_dir=$2

	if [ ! -d $tools_dir ];then
		minirc_upgrade_log "$tools_dir not exist, npu_manage_tools install failed!"
		return 1
	fi

	for file in $npu_manage_tools;
	do
		tmpfile=$src_dir/$file
		if [ ! -f $tmpfile ];then
			minirc_upgrade_log "file $tmpfile not existed, install failed"
			return 1
		fi

		cp $tmpfile $tools_dir
		if [ $? -ne 0 ];then
			minirc_upgrade_log "cp $tmpfile $tools_dir failed"
			return 1
		fi
		
		chmod +x $tools_dir/$file
	done

	minirc_upgrade_log "install npu management tools success"
	return 0
}

# --------------------------main process---------------------------

INSTALL_CACHE_DIR=$1
INSTALL_DST_DIR=/usr/local/sbin

install_npu_manage_tools ${INSTALL_CACHE_DIR}/mini_developerkit/ $INSTALL_DST_DIR
if [ $? -ne 0 ];then
	exit 1
fi

minirc_upgrade_log "customized install finish"
exit 0
