#!/bin/bash

# the definition of return value
#1: lack enough sd space
#2: unpack rar package failed
#3: version verify failed
#4: undefined error



check_package()
{
	cd $INSTALL_CACHE_DIR
	./check_sha.sh
	if [ $? -ne 0 ]; then
	    echo "verify the package fail"
		exit 3
	fi
}


copy_firmware()
{
	if [ -d $FWM_DIR ]; then
		rm -f $FWM_DIR/*
	else
		mkdir -p $FWM_DIR
	fi
	
	cp $INSTALL_CACHE_DIR/mini_developerkit/nve.bin $FWM_DIR/
	cp $INSTALL_CACHE_DIR/mini_developerkit/xloader.bin $FWM_DIR/
	cp $INSTALL_CACHE_DIR/mini_developerkit/HI1910_FPGA_DDR.fd $FWM_DIR/
	cp $INSTALL_CACHE_DIR/mini_developerkit/lpm3.img $FWM_DIR/
	cp $INSTALL_CACHE_DIR/mini_developerkit/tee.bin $FWM_DIR/
	cp $INSTALL_CACHE_DIR/mini_developerkit/dt.img $FWM_DIR/
	cp $INSTALL_CACHE_DIR/mini_developerkit/Image $FWM_DIR/
	cp $INSTALL_CACHE_DIR/mini_developerkit/sys_version.conf $FWM_DIR/
}
	

INSTALL_CACHE_DIR="$1/var/mini/install_cache"
FWM_DIR="$1/fw"

echo "writing files to sdcard, please waiting several minutes ..."

check_package
copy_firmware

exit 0
