

set_led_state()
{
	#stats  booting  upgrading finish
	state=$1
	if [ $state == "booting" ]; then
		echo "led3:1led4:0" > /var/davinci/driver/led
	elif [ $state == "upgrading" ]; then
		echo  "led3:2led4:2" > /var/davinci/driver/led
	elif [ $state == "finish" ]; then
		echo "led3:1led4:1" > /var/davinci/driver/led
	fi
}

###############################################
#
#			Pre Init.
#
###############################################
pre_init_services()
{
	set_led_state "booting"
	/var/minirc_led &


	echo 1    4    1    7 > /proc/sys/kernel/printk
}


###############################################
#
#			Load Drivers.
#
###############################################

ko_check()
{
	ko=$1

	insmod $ko
	if [ $? -ne 0 ]; then
		echo "[DEBUG] `date` insmod $ko fail"
	else
		echo "[DEBUG] `date` insmod $ko succ"
    fi
}

load_device_modules()
{
	echo "load device modules"
	ko_check /var/davinci/driver/drv_dfm.ko
	ko_check /var/davinci/driver/drv_nor_flash.ko
	ko_check /var/davinci/driver/drv_e2prom.ko
	ko_check /var/davinci/driver/drv_pca6416.ko
	echo /dev/mtd1 > /sys/module/hisi_nve/parameters/nve
	ko_check /var/davinci/driver/drv_pcie.ko
	ko_check /var/davinci/driver/ipc_drv.ko
	ko_check /var/davinci/driver/drv_platform.ko
	ko_check /var/davinci/driver/drv_devmng.ko
	ko_check /var/davinci/driver/drv_devdrv.ko
	ko_check /var/davinci/driver/drv_dvpp.ko
	ko_check /var/davinci/driver/drv_log.ko
	ko_check /var/davinci/driver/drv_mdio.ko
	ko_check /var/davinci/driver/drv_lsw.ko
	ko_check /var/davinci/driver/drv_gmac.ko
	ko_check /var/davinci/driver/drv_prof.ko
	ko_check /var/davinci/driver/drv_aicpu.ko
	ko_check /var/davinci/driver/drv_fan.ko
	ko_check /var/davinci/driver/drv_pwm.ko
	ko_check /var/davinci/driver/drv_spi.ko
	ko_check /var/davinci/driver/tee_drv.ko
	ko_check /var/davinci/driver/drv_upgrade.ko
        lspci | grep 3559
        if [ $? -eq 0 ]; then
                ko_check /var/davinci/driver/hi35xx_dev_host.ko
                ko_check /var/davinci/driver/mcc_drv_host.ko
                ko_check /var/davinci/driver/mcc_usrdev_host.ko
        fi
	ko_check /var/davinci/driver/drv_watchdog.ko
	echo "finish load device modules"
}

###############################################
#
#			Load Config
#
###############################################

load_slogd()
{
	slog_path="/usr/slog"
	if [ ! -d $slog_path ];then
		mkdir -p $slog_path
		chmod 700 $slog_path
		grep "^$username" /etc/passwd >/dev/null 2>&1
		if [ $? -eq 0 ];then
			chown -f $username:$usergroup $slog_path
		fi
	fi

	echo "start slogd"
	grep "^$username" /etc/passwd >/dev/null 2>&1
	if [ $? -eq 0 ];then
		su - ${username} -c "nohup /var/slogd >/dev/null 2>&1 &"
	else
		nohup /var/slogd >/dev/null 2>&1 &
	fi
	echo "start sklogd"
	nohup /var/sklogd >/dev/null 2>&1 &
}


###############################################
#
#			Load Services.
#
###############################################
set_hdc_config()
{
        sed -i "4d" /etc/hdcBasic.cfg
        sed -i "3a TRANS_TYPE              = 0" /etc/hdcBasic.cfg
        sleep 1

}
load_hdcd()
{
        cp -f /var/hdcd /sbin/
        chmod -f 550 /sbin/hdcd
        chown -f ${username}:${usergroup} /sbin/hdcd
        echo "start hdcd:"
        su ${username} -c "/sbin/hdcd"
}
load_media_server()
{
        if [ -f  /var/.camera_lock0 ];then
		rm /var/.camera_lock0
        fi
	
        if [ -f  /var/.camera_lock1 ];then
		rm /var/.camera_lock1
        fi

        if [ -f  /var/.mic_lock ];then
		rm /var/.mic_lock
        fi
	
	rm /var/libmedia_*.log
	echo "start media_server:"
	/var/libmedia_server > /dev/null &
}
load_matrix_daemon_process_monitor()
{
	echo "start ProcessMonitor:"
	su ${username} -c "nohup /var/processmonitor >/dev/null 2>&1 &"
}
load_IDE_daemon()
{
	##add gdb attach permission for HwHiAiUser
    if [ ! -f /etc/sysctl.d/10-ptrace.conf ];then
        if [ ! -d /etc/sysctl.d ];then
            mkdir -p /etc/sysctl.d
        fi
        echo "kernel.yama.ptrace_scope = 0" >> /etc/sysctl.d/10-ptrace.conf
    else
        result=`grep -rn "kernel.yama.ptrace_scope" /etc/sysctl.d/10-ptrace.conf`
        if [ "x$result" != x"" ];then
            sed -i '/kernel.yama.ptrace_scope/d' /etc/sysctl.d/10-ptrace.conf
            echo "kernel.yama.ptrace_scope = 0" >> /etc/sysctl.d/10-ptrace.conf
        else
            echo "kernel.yama.ptrace_scope = 0" >> /etc/sysctl.d/10-ptrace.conf
        fi
    fi
    echo "start IDE-daemon:"
	su $username -c "nohup /var/IDE-daemon-device >/dev/null 2>&1 &"
	su $username -c "nohup /var/IDE-daemon-host >/dev/null 2>&1 &"
}
load_dmp_daemon()
{
        echo "start DMP daemon"
        touch /var/run/dmp_daemon.pid
        chmod -f 660 /var/run/dmp_daemon.pid
        chown -f ${username}:${usergroup} /var/run/dmp_daemon.pid
	chmod -f 777 /mnt
        su - ${username} -c "nohup /var/dmp_daemon -I -U 8087 >/dev/null 2>&1 &"
}
load_tee_daemon()
{
		echo "start TEE daemon"
		nohup /var/tee-supplicant >/dev/null 2>&1 &
}
load_proc_monitor()
{
	echo Current Time aicpufw_monitor:`date`
	su ${username} -c "nohup /var/aicpufw_monitor >/dev/null 2>&1 &"
}

load_device_services()
{
	load_slogd
	set_hdc_config
	load_hdcd
	load_proc_monitor
	load_media_server
	load_matrix_daemon_process_monitor
	load_IDE_daemon
	load_dmp_daemon
	load_tee_daemon
}

init_hugepages()
{
	echo "init the num of the hugepages"
	local TotalMem=`cat /proc/meminfo | grep MemTotal | awk '{ print $2 }'`
	local nr_hugepages=`cat /proc/cmdline | tr -s ' ' '\n' | grep nr_hugepages | awk -F '=' '{print $2}'`

	#nr_hugepages is the ratio of hugetlb memory to total available memory
	if [ "$nr_hugepages" -ge 0 -a "$nr_hugepages" -le 100 ] 2>/dev/null ;then
		if [ "$nr_hugepages" -ge 50 ] 2>/dev/null ;then
			echo "Customer' val is too big, reduce to 50%"
			nr_hugepages=50
		fi
		val=$((TotalMem * nr_hugepages / 100 / 2048))
		echo $val > /proc/sys/vm/nr_hugepages
		echo "init_hugepages set the nr_hugepages to $val"
		return
	fi
	# value not in [0-100], set to 25% default
	if [ "$nr_hugepages" -gt 100 ] 2>/dev/null ;then
		val=$((TotalMem * 25 / 100 / 2048))
		echo $val > /proc/sys/vm/nr_hugepages
		echo "Customer's value is invalidated, Default set the nr_hugepages to 25%($val)"
		return
	fi
}

init_mem_waterline()
{
	echo "set waterline is 128M"
	# waterline is 128M
	WATERLINE=131072

	#disable panic on oom
	echo 0 > /proc/sys/vm/panic_on_oom

	#disable mem overcommit
	echo 2 > /proc/sys/vm/overcommit_memory

	#get system available mem
	local total=`cat /proc/meminfo  | grep MemTotal | awk '{print $2}'`

	#hugetlb has its own accounting separate from the core VM
	#The total mem should sub hugepages
	#tips: total mem unit is KB.
	local nr_hugepages=`cat /proc/sys/vm/nr_hugepages`
	total=$((total - nr_hugepages * 2 * 1024))

	#set overcommit waterline
	echo $((total-WATERLINE)) > /proc/sys/vm/overcommit_kbytes
	echo "overcommit_kbytes" `cat /proc/sys/vm/overcommit_kbytes` "kb, warterline is" $WATERLINE "kb"
}

init_file_pagecache()
{
	# mini-rc use SD to mount rootfs. When there's a lot of IO request, such as tar, logd, read/write
	# It may block the process. Should reduce the backgroud queue.
	# dirty_background_ratio(default 10) change to 1
	# dirty_ratio(default 20) change to 2

	echo 1 > /proc/sys/vm/dirty_background_ratio
	echo 2 > /proc/sys/vm/dirty_ratio
}

init_cpusets()
{
	echo "create CtrlCPU and AICPU cgroup in the cpuset virtual file system"
	local MaxCpuID=`cat /proc/cpuinfo | grep "processor" | tail -1 | tr -cd "[0-9]"`

	if [ ! -d "/sys/fs/cgroup" ]; then
		mount -t tmpfs cgroup_root /sys/fs/cgroup
	fi

	if [ ! -d "/sys/fs/cgroup/cpuset" ]; then
		mkdir /sys/fs/cgroup/cpuset
		mount -t cgroup -ocpuset cpuset /sys/fs/cgroup/cpuset
	fi

	mkdir /sys/fs/cgroup/cpuset/CtrlCPU
	mkdir /sys/fs/cgroup/cpuset/AICPU

	cat /sys/fs/cgroup/cpuset/cpuset.mems > /sys/fs/cgroup/cpuset/CtrlCPU/cpuset.mems
	cat /sys/fs/cgroup/cpuset/cpuset.mems > /sys/fs/cgroup/cpuset/AICPU/cpuset.mems

	cat /sys/bus/cpu/devices/cpu0/topology/core_siblings_list > /sys/fs/cgroup/cpuset/CtrlCPU/cpuset.cpus
	cat /sys/bus/cpu/devices/cpu$MaxCpuID/topology/core_siblings_list > /sys/fs/cgroup/cpuset/AICPU/cpuset.cpus
}

attach_tasks()
{
	echo "make all non-AI tasks attach to CtrlCPU cgroup"
	while read line
	do
		echo $line >> /sys/fs/cgroup/cpuset/CtrlCPU/tasks 2> /dev/null
	done < /sys/fs/cgroup/cpuset/tasks
}

#if mini boot fail 3 times, stop booting mini
boot_status_check()
{
    if [ ! -e /var/davinci/log/boot_fail_count ]; then
		echo "1" > /var/davinci/log/boot_fail_count
	else
		cnt_str=$(cat /var/davinci/log/boot_fail_count)
		cnt=$((cnt_str))
		if [ $cnt -gt 2 ]; then
			echo "##############################################################"
			echo "# mini booting failed 3 times, stop booting mini             #"
			echo "# you can remove the file(/var/davinci/log/boot_fail_count)  #"
			echo "# to recover the booting procedures                          #"
			echo "##############################################################"
		    exit
		else
			echo "$((cnt+1))" > /var/davinci/log/boot_fail_count
			echo "booting failed count:$cnt_str"
		fi
	fi
}

mount_disk() {
    grep -qs '/var/dlog' /proc/mounts >> /dev/null 2>&1
    ret=$?
    if [ -e /dev/mmcblk1p2 ] && [ $ret -ne 0 ]; then
        mkdir /var/oldlog
        rsync -a --include '*/' --exclude '*'  /var/dlog/ /var/oldlog/
        mount /dev/mmcblk1p2   /var/dlog
        rsync -a --include '*/' --exclude '*'  /var/oldlog/ /var/dlog/
        chmod -f 750 /var/dlog && chown -f ${username}:${usergroup} /var/dlog
        rm -rf /var/oldlog
    fi

    grep -qs '/home' /proc/mounts >> /dev/null 2>&1
    ret=$?
    if [ -e /dev/mmcblk1p3 ] && [ $ret -ne 0 ]; then
        mount /dev/mmcblk1p3   /home
    fi
}
change_dev_mode()
{
    cd /dev/
    chmod -f 660 aicpufw_drv davinci0 davinci_manager devmm_svm hi_dvpp log_drv mtd1 mtd6 nve prof_drv svm0 tee0 teepriv0 random urandom  PCA6416 pwm eeprom_m24256 hi_sfc i2c0_slave i2c-0 upgrade
    chown -f ${username}:${usergroup} aicpufw_drv davinci0 davinci_manager devmm_svm hi_dvpp log_drv mtd1 mtd6 nve prof_drv svm0 tee0 teepriv0 random urandom  PCA6416 pwm eeprom_m24256 hi_sfc i2c0_slave i2c-0 upgrade
    cd /sys/kernel/
    chmod -f 0777 debug
    cd debug
    chmod -f 0777 fan
    chmod -f 0444 /sys/kernel/debug/fan/fan_speed
    chown -f ${username}:${usergroup} /sys/kernel/debug/fan/fan_speed
    cd /dev/
}
change_proc_mode() {
    if [ -d /proc/flash ]; then
        chmod -f 550 /proc/flash
        chown -f ${username}:${usergroup} /proc/flash
        chmod -f 440 /proc/flash/*
        chown -f ${username}:${usergroup} /proc/flash/*
    fi
    if [ -f /proc/mtd ]; then
        chmod -f 440 /proc/mtd
        chown -f ${username}:${usergroup} /proc/mtd
    fi
    return 0
}

get_boot_partition() {
    boot_cmd_path=/proc/cmdline
    if [ -e ${boot_cmd_path} ]; then
        boot_area=`cat /proc/cmdline | awk '{for(i=1;i<=NF;i++){split($i,cmd_str,"="); if(cmd_str[1]=="slaveboot"){print cmd_str[2]}}}'`
        if [ $boot_area -eq 1 ]; then
            partition_flag="backup"
        fi
    fi
}

system_boot_check() {
    if [ -e /var/davinci/firmware/upgrade_failed ] && [ "$partition_flag" = "main" ]; then
        exit 0
    fi
}

###############################################
#
#			main process.
#
###############################################
username=HwHiAiUser
usergroup=HwHiAiUser
partition_flag="main"
echo "current version: $(cat /etc/sys_version.conf)"
get_boot_partition
system_boot_check
boot_status_check
echo Current Time pre_init_services:`date`
mount_disk
pre_init_services
echo Current Time load device modules:`date`
init_hugepages
init_mem_waterline
init_file_pagecache
init_cpusets
attach_tasks
load_device_modules
ifdown eth0
chmod -f 666 /dev/mtd6
#services leads on driver chown
change_dev_mode

load_device_services
attach_tasks
sh /var/usb_ether.sh

#boot success, sync sd/emmc component
/var/davinci/firmware/upgrade-tool --sync

#boot success, remove file(boot_fail_count)
if [ -e /var/davinci/firmware/upgrade_failed ]; then
    rm /var/davinci/firmware/upgrade_failed
fi
rm /var/davinci/log/boot_fail_count
chmod -f 666 /sys/fs/cgroup/cpuset/AICPU/tasks 
chmod -f 750 /var/davinci/log
chmod -f 640 /var/davinci/log/boot_fail_count /var/davinci/driver/led /var/davinci/log/upgrade.log
chmod -f a+w /var/
chmod -f 666 /dev/mcc_userdev
chmod -f 666 /dev/pcie_dma
change_dev_mode
change_proc_mode
systemctl restart networking
